C--THIS FILE HAS BEEN CONVERTED BY AP9TO10----
C$ #5 BY: AA DATE:  16-FEB-2001 Added Protein, Extractive, Sol. Lig.
C$ #4 BY: RJW DATE:  20-NOV-1998 Move NH4Acet to Mixed Substream (S1)
C$ #3 BY: VLP DATE:  26-JUL-18-AUG-1998 DEVELOPED WWT MODEL
C$ #2 BY: ANAVI DATE: 15-NOV-1994 FIXED TYPO INI(NINT)-->INT(NINT)
C$ #1 BY: ANAVI DATE:  1-JUL-1994 NEW FOR USER MODELS
C
C     User Unit Operation Model for an Anaerobic Digestor
C
      SUBROUTINE USRAN4 (NSIN,    NINFI,  SIN1,   SIN2,    SIN3,
     2                   SIN4,    SINFI,  NSOUT,  NINFO,    SOUT1,
     3                   SOUT2,   SOUT3,  SOUT4,  SINFO,   NSUBS,
     4                   IDXSUB,  ITYPE,  NINT,   INT,     NREAL,
     5                   REAL,    IDS,    NPO,    NBOPST,  NIWORK,
     6                   IWORK,   NWORK,  WORK,   NSIZE,   SIZE,
     7                   INTSIZ,  LD)
C
      IMPLICIT REAL*8 (A-H, O-Z)
C
      INTEGER DMS_KCCIDC,DMS_IFCMNC
      DIMENSION SIN1(1), SIN2(1), SIN3(1), SIN4(1), SOUT1(1),
     2          SOUT2(1), SOUT3(1), SOUT4(1), IDXSUB(NSUBS),
     3          ITYPE(NSUBS), INT(NINT), REAL(NREAL), IDS(2,13),
     4          NBOPST(6,NPO), IWORK(NIWORK), WORK(NWORK),
     5          SIZE(NSIZE), INTSIZ(NSIZE)
C
      DIMENSION XAI(99)   ,  IDXAI(99) , XCI(99)  , IDXCI(99) ,
     2          XAO(99)   ,  IDXAO(99) , XCO(99)  , IDXCO(99) ,
     3          IPROG(2)  ,  RETN(228) , IRETN(6) , NFLAGW(11)
C
C
#include "ppexec_user.cmn"
      EQUIVALENCE (RMISS, USER_RUMISS)
      EQUIVALENCE (IMISS, USER_IUMISS)
C
      COMMON /WWLOAD/ CODTOT, BODTOT, CODDAY, BODDAY
C
C
#include "dms_ncomp.cmn"
C
#include "shs_stwork.cmn"
      EQUIVALENCE (KAI, STWORK_KA1)
      EQUIVALENCE (MKBAS, STWORK_NDUM)
      EQUIVALENCE (MKPHAS, STWORK_NBLM)
      EQUIVALENCE (MTAPP, STWORK_NCOVAR)
      EQUIVALENCE (MKBASS, STWORK_NWR)
      EQUIVALENCE (MTAPPS, STWORK_NIWR)
      EQUIVALENCE (SSALT, STWORK_RDUM1)
      EQUIVALENCE (VSALT, STWORK_RDUM2)
      EQUIVALENCE (FSALT, STWORK_FFSALT)
C
#include "dms_stwkwk.cmn"
      INTEGER IDUM3(2)
      REAL*8 RDUM(21)
      EQUIVALENCE (NCPM, STWKWK_NCPMOO)
      EQUIVALENCE (NCPCS, STWKWK_NCPCSO)
      EQUIVALENCE (NCPNC, STWKWK_NCPNCO)
      EQUIVALENCE (IDUM3(1), STWKWK_KRSTRT)
      EQUIVALENCE (IDUM3(2), STWKWK_IDUMY)
      EQUIVALENCE (TCALC, STWKWK_TCALC)
      EQUIVALENCE (PCALC, STWKWK_PCALC)
      EQUIVALENCE (VCALC, STWKWK_VCALC)
      EQUIVALENCE (QCALC, STWKWK_QCALC)
      EQUIVALENCE (BETCAL, STWKWK_BETA)
      EQUIVALENCE (RDUM(1), STWKWK_T)
      EQUIVALENCE (RDUM(2), STWKWK_P)
      EQUIVALENCE (RDUM(3), STWKWK_VFRAC)
      EQUIVALENCE (RDUM(4), STWKWK_Q)
      EQUIVALENCE (RDUM(5), STWKWK_TINIT)
      EQUIVALENCE (RDUM(6), STWKWK_PINIT)
      EQUIVALENCE (RDUM(7), STWKWK_DD(1))
      EQUIVALENCE (RDUM(8), STWKWK_DD(2))
      EQUIVALENCE (RDUM(9), STWKWK_DD(3))
      EQUIVALENCE (RDUM(10), STWKWK_DD(4))
      EQUIVALENCE (RDUM(11), STWKWK_DD(5))
      EQUIVALENCE (RDUM(12), STWKWK_DD(6))
      EQUIVALENCE (RDUM(13), STWKWK_DD(7))
      EQUIVALENCE (RDUM(14), STWKWK_DD(8))
      EQUIVALENCE (RDUM(15), STWKWK_DD(9))
      EQUIVALENCE (RDUM(16), STWKWK_DD(10))
      EQUIVALENCE (RDUM(17), STWKWK_DD(11))
      EQUIVALENCE (RDUM(18), STWKWK_DD(12))
      EQUIVALENCE (RDUM(19), STWKWK_DD(13))
      EQUIVALENCE (RDUM(20), STWKWK_DD(14))
      EQUIVALENCE (RDUM(21), STWKWK_DD(15))
      COMMON /IDXCC / IDXCC(1)
      COMMON /IDXNCC/ IDXNCC(1)
      COMMON / MW   / XMW(1)
#include "dms_rptglb.cmn"
#include "dms_plex.cmn"
      DIMENSION B(1)
      EQUIVALENCE (IB(1),B(1))
C
C     VARIABLES IN ARGUMENT LIST
C
C     VAR          I/O     TYPE     DIM      DESCRIPTION
C     ----         ---     ----     ---      ----------------
C     SINFO         O       R                OUTLET WORK STREAM VECTOR
C     SIN1         I/O      R                INLET WASTEWATER STREAM VEC
C     SOUT1         O       R                OUTLET STREAM
C     NSUBS         I       I                NUMBER OF SUBSTREAMS
C     IDXSUB        I       I      NSUBS     SUBSTREAM INDEX VECTOR
C     ITYPE         I       I      NSUBS     SUBSTREAM TYPE VECTOR
C     NINT          I       I                LENGTH OF INPUT VECTOR
C     INT          I/O      I      NINT      INPUT INTEGER VECTOR
C     NREAL         I       I                LENGTH OF INPUT REAL VECTOR
C     REAL         I/O      R      NREAL     INPUT REAL VECTOR
C     IDS           I       I      2, 13     ID VECTOR
C     NPO           I       I                NUMBER OF PHYSICAL PROPERTY
C     NBOPST        I       I      3, NPO    PHYSICAL PROPERTY OPTION SE
C     NIWORK        I       I                LENGTH OF INPUT INTEGER WOR
C     IWORK         I       I      NIWORK    INPUT INTEGER WORK VECTOR
C     NWORK         I       I                LENGTH OF INPUT REAL WORK V
C     WORK          I       R      NWORK     INPUT REAL WORK VECTOR
C     REAL(1)       I       R                COD CONVERSION (FRAC)
C     REAL(2)       I       R                FRACTION CH4 YIELD ON COD
C     REAL(3)       I       R                FRACTION CELL MASS YIELD ON
C     REAL(4)       I       R                FRACTION OF CH4 IN OUTLET G
C     REAL(5)       I       R                FRACTION OF SOLUBLE SULFATE
C                                            COMPONENTS TO H2S
C
C  *********************************************************************
C  *                                                                   *
C  *          SET COMPONENT INDICES BY COMPONENT ID                    *
C  *                                                                   *
C  *********************************************************************
C
C     THIS ALLOWS MANIPULATION OF THE COMPONENTS BY THE INDICE
C     RATHER THAN THE POSITION IN THE COMPONENT MATRIX.
C
C  *********************************************************************
C  *                                                                   *
C  *          IN-HOUSE DATABASE COMPONENTS                             *
C  *                                                                   *
C  *********************************************************************
      NGLUC = DMS_KCCIDC('GLUCOSE')
      NCELU = DMS_KCCIDC('CELLULOSE')
      NXYLO = DMS_KCCIDC('XYLOSE')
      NXYLA = DMS_KCCIDC('XYLAN')
      NLIGN = DMS_KCCIDC('LIGNIN')
      NCELL = DMS_KCCIDC('CELLULASE')
      NBIOM = DMS_KCCIDC('BIOMASS')
      NZYMO = DMS_KCCIDC('ZYMO')
      NUNKN = DMS_KCCIDC('UNKNOWN')
      NSOLS = DMS_KCCIDC('SOLSLDS')
      NEXTR = DMS_KCCIDC('EXTRACT')
      NPROT = DMS_KCCIDC('PROTEIN')
      NGYPS = DMS_KCCIDC('GYPSUM')
      NACET = DMS_KCCIDC('ACETATE')
C
C  *********************************************************************
C  *                                                                   *
C  *          IN-HOUSE DATABASE ALIASES                                *
C  *                                                                   *
C  *********************************************************************
C
      NARAB = DMS_KCCIDC('ARABINOS')
      NGALA = DMS_KCCIDC('GALACTOS')
      NMANS = DMS_KCCIDC('MANNOSE')
      NARAN = DMS_KCCIDC('ARABINAN')
      NMANN = DMS_KCCIDC('MANNAN')
      NGALN = DMS_KCCIDC('GALACTAN')
      NGLUO = DMS_KCCIDC('GLUCOLIG')
      NCELB = DMS_KCCIDC('CELLOB')
      NXYLG = DMS_KCCIDC('XYLOLIG')
      NTAR  = DMS_KCCIDC('TAR')
      NMANO = DMS_KCCIDC('MANOLIG')
      NGALO = DMS_KCCIDC('GALAOLIG')
      NARAO = DMS_KCCIDC('ARABOLIG')
      NACEO = DMS_KCCIDC('ACETOLIG')
      NXYLL = DMS_KCCIDC('XYLITOL')
      NSLLN = DMS_KCCIDC('LGNSOL')
C
C  *********************************************************************
C  *                                                                   *
C  *          SOLIDS DATABASE                                          *
C  *                                                                   *
C  *********************************************************************
C
      NCASO = DMS_KCCIDC('CASO4')
      NCAH2 = DMS_KCCIDC('CAH2O2')
      NASH = DMS_KCCIDC('ASH')
C
C  *********************************************************************
C  *                                                                   *
C  *          PURECOMPS DATABASE                                       *
C  *                                                                   *
C  *********************************************************************
C
      NETOH = DMS_KCCIDC('ETHANOL')
      NH2O = DMS_KCCIDC('H2O')
      NFURF = DMS_KCCIDC('FURFURAL')
      NHMF = DMS_KCCIDC('HMF')
      NH2SO = DMS_KCCIDC('H2SO4')
      NN2 = DMS_KCCIDC('N2')
      NCO2 = DMS_KCCIDC('CO2')
      NO2 = DMS_KCCIDC('O2')
      NCH4 = DMS_KCCIDC('CH4')
      NNO = DMS_KCCIDC('NO')
      NNO2 = DMS_KCCIDC('NO2')
      NNH3 = DMS_KCCIDC('NH3')
      NLACI = DMS_KCCIDC('LACID')
      NAACI = DMS_KCCIDC('AACID')
      NNH4O = DMS_KCCIDC('NH4OH')
      NNH4S = DMS_KCCIDC('NH4SO4')
      NNH4A = DMS_KCCIDC('NH4ACET')
      NGLYC = DMS_KCCIDC('GLYCEROL')
      NSUCC = DMS_KCCIDC('SUCCACID')
      NDENA = DMS_KCCIDC('DENAT')
      NOIL = DMS_KCCIDC('OIL')
      NCSL = DMS_KCCIDC('CSL')
      NCNUT = DMS_KCCIDC('CNUTR')
      NWNUT = DMS_KCCIDC('WNUTR')
      NSO2 = DMS_KCCIDC('SO2')
      NH2S = DMS_KCCIDC('H2S')
C
C  *********************************************************************
C  *                                                                   *
C  *        DEFINE THE OFFSETS FOR THE SUBSTREAMS                      *
C  *                                                                   *
C  *********************************************************************
C
C     S1 IS MIXED AND S2 IS CISOLID.
C
      S1=IDXSUB(1) - 1
      S2=IDXSUB(2) - 1
C
C  *********************************************************************
C  *                                                                   *
C  *       FIND THE MOLECULAR WEIGHT FOR COMPONENTS                    *
C  *       IN THE MIXED SS, CELL MASS AND (NH4)2SO4                    *
C  *       ALSO PROTEIN, EXTRACT, LGNSOL                               *
C  *********************************************************************
C
      LMW = DMS_IFCMNC ('MW')
      CMW = B(LMW + NBIOM)
      GMW = B(LMW + NGLUC)
      XYMW = B(LMW + NXYLO)
      UMW = B(LMW + NUNKN)
      SMW = B(LMW + NSOLS)
      AMW = B(LMW + NARAB)
      GAMW = B(LMW + NGALA)
      WAMW = B(LMW + NMANS)
      GOMW = B(LMW + NGLUO)
      CBMW = B(LMW + NCELB)
      XGMW = B(LMW + NXYLG)
      WOMW = B(LMW + NMANO)
      GLMW = B(LMW + NGALO)
      AOMW = B(LMW + NARAO)
      AEMW = B(LMW + NACEO)
      XLMW = B(LMW + NXYLL)
      EMW = B(LMW + NETOH)
      FMW = B(LMW + NFURF)
      HMW = B(LMW + NHMF)
      C4MW = B(LMW + NCH4)
      ALMW = B(LMW + NLACI)
      AAMW = B(LMW + NAACI)
      GYMW = B(LMW + NGLYC)
      SUMW = B(LMW + NSUCC)
      DMW = B(LMW + NDENA)
      WLMW = B(LMW + NOIL)
      WMW = B(LMW + NH2O)
      SAMW = B(LMW + NH2SO)
      W1MW = B(LMW + NN2)
      CO2MW = B(LMW + NCO2)
      W2MW = B(LMW + NO2)
      W3MW = B(LMW + NNO)
      W4MW = B(LMW + NNO2)
      AMMW = B(LMW + NNH3)
      CSMW = B(LMW + NCSL)
      CNMW = B(LMW + NCNUT)
      WNMW = B(LMW + NWNUT)
      WSOMW =B(LMW + NSO2)
      HSMW = B(LMW + NH2S)
      ASMW = B(LMW + NNH4S)
      AMAMW = B(LMW + NNH4A)
      AHMW  = B(LMW + NNH4O)
      EXMW = B(LMW + NEXTR)
      PRMW = B(LMW + NPROT)
      SLMW = B(LMW + NSLLN)
C
C  *********************************************************************
C  *                                                                   *
C  *       COPY INLET STREAM TO OUTLET STREAM                          *
C  *                                                                   *
C  *********************************************************************
C
C
C Copy Each Component, NCC - Number Conventional Components
C NCC+1 Total Flow
C S1 is MIXED substream, S2 is CISOLID
C
      DO 100 K = 1, NCOMP_NCC+1
         SOUT1(S1+K) = SIN1(S1+K)
         SOUT1(S2+K) = SIN1(S2+K)
         WRITE(USER_NHSTRY,*)'K (Component No.) = ',K
         WRITE(USER_NHSTRY,*)'SOUT1(S1) MIXED (kmol/s) = ',SOUT1
     +         (S1+K)
         WRITE(USER_NHSTRY,*)
     +         'SOUT1(S2) CISOLID (kmol/s) = ',SOUT1(S2+K)
  100 CONTINUE
C
C Copy Stream Properties
C NCC+2 Temperature (K)
C NCC+3 Pressure (Pa)
C NCC+4 Enthalpy (J/Kg)
C NCC+5 Molar Vapor Fraction
C NCC+6 Molar Liquid Fraction
C NCC+7 Entropy (J/Kg K)
C NCC+8 Density (Kg/m^3)
C NCC+9 Molecular Weight
C
      DO 200 K=NCOMP_NCC+2, NCOMP_NCC+9
         SOUT1(S1+K) = SIN1(S1+K)
         SOUT1(S2+K) = SIN1(S2+K)
         WRITE(USER_NHSTRY,*)'S1M,SO1M= ',SIN1(S1+K),SOUT1(S1+K)
         WRITE(USER_NHSTRY,*)'SIC,SO1C= ',SIN1(S2+K),SOUT1(S2+K)
  200 CONTINUE
C
C
C  *********************************************************************
C  *                                                                   *
C  *       COPY ALL OF THE SOLUBLE NON-CARBON-CONTAINING COMPOUNDS     *
C  *       TO THE OUTLET STREAM.                                       *
C  *********************************************************************
C
C     THESE COMPONENTS WILL NOT BE CONVERTED.
C
       SOUT1(S1+NH2O)  = SIN1(S1+NH2O)
       SOUT1(S1+NH2SO) = SIN1(S1+NH2SO)
       SOUT1(S1+NN2)   = SIN1(S1+NN2)
       SOUT1(S1+NCO2)  = SIN1(S1+NCO2)
       SOUT1(S1+NO2)   = SIN1(S1+NO2)
       SOUT1(S1+NNO)   = SIN1(S1+NNO)
       SOUT1(S1+NNO2)  = SIN1(S1+NNO2)
       SOUT1(S1+NNH3)  = SIN1(S1+NNH3)
       SOUT1(S1+NCSL)  = SIN1(S1+NCSL)
       SOUT1(S1+NCNUT) = SIN1(S1+NCNUT)
       SOUT1(S1+NWNUT) = SIN1(S1+NWNUT)
       SOUT1(S1+NSO2)  = SIN1(S1+NSO2)
       SOUT1(S1+NH2S)  = SIN1(S1+NH2S)
       SOUT1(S1+NNH4O) = SIN1(S1+NNH4O)
C
C
C  *********************************************************************
C  *                                                                   *
C  *       SET THE METHANE YIELD                                       *
C  *                                                                   *
C  *********************************************************************
C
      CH4MAX = 350.
C CH4MAX IS THE MAXIMUM YIELD OF METHANE (L CH4/KG COD CONVERTED)
C AND WAS PROVIDED BY J. RUOCCO
C
      Write(USER_NHSTRY,101)Real(1),Real(2),Real(3),Real(4),Real
     +      (5)
101   Format(' WWT Input Parameters',/,
     1       ' COD Converted in Anerobic:      ',g12.5,/,
     2       ' Methane Yield, Kg CH4/Kg COD:   ',g12.5,/,
     3       ' Cell Yield, Kg Cellmass/Kg COD: ',g12.5,/,
     4       ' Final Concentration of CH4:     ',g12.5,/,
     5       ' Frac of soluble SO4 converted:  ',g12.5)
      CODCON = REAL(1)
      CELLY = REAL(3)
      CODREM = 1.0-CODCON-CELLY
      CH4YLD = REAL(2)
C
C CODCON IS THE COD CONVERTED IN ANAEROBIC DIGESTION
C CELLY IS THE CELL YIELD KG CELL MASS/KG COD CONVERTED
C CODREM IS THE COD REMAINING AFTER ANAEROBIC DIGESTION
C CH4YLD IS THE METHANE YIELD KG CH4/KG COD CONVERTED
C
C  *********************************************************************
C  *                                                                   *
C  *       MODIFY THE METHANE YIELD BASED ON TEMP                      *
C  *                                                                   *
C  *********************************************************************
C
C THE FOLLOWING METHANE YIELD RELATIONSHIP BASED ON THE COD
C CONVERTED WAS OBTAINED FROM J. RUOCCO.
C
      WRITE(USER_NHSTRY,*)'CODTOT,BODTOT= ',CODTOT, BODTOT
      IF (CODCON .GE. 0.9) THEN
         CODCON = 0.9
         CH4OUT = CODTOT*CH4MAX*CH4YLD*CODCON
      ELSE IF (CODCON .GT. 0.6) THEN
         CH4OUT = CODTOT*CH4MAX*CH4YLD*(1.0 + (CODCON - 0.9)*2.0)
      ELSE
         CH4OUT = CODTOT*CH4MAX*CH4YLD*(0.4 + (CODCON - 0.6)*5.0)
      END IF
C
C  *********************************************************************
C  *                                                                   *
C  *       CALCULATE METHANE PRODUCED                                  *
C  *                                                                   *
C  *********************************************************************
C
C     CONVERT L OF METHANE TO KG-MOL (SI UNITS)
      RHO = 1.0/(82.05*298.16)
C  RHO IS THE DENSITY OF CH4 AT 1 ATM AND 25C (298 K)
C  AND HAS UNITS OF KG MOL/L
C  8.314 IS THE UNIVERSAL GAS CONSTANT (ATM-L/KG-MOL K)
      CH4PRO = CH4OUT*RHO/3600.
C 3600 SEC/HR
      CH4MAS = CH4PRO*C4MW
C CH4MAS IS THE MASS FLOWRATE (KG/S) OF METHANE FROM THE SYSTEM
C      WRITE(NHSTRY,*)'CH4PRO= ',CH4PRO
C CH4PRO IS THE AMOUNT OF METHANE PRODUCED KG-MOL/S
C
      SOUT1(S1+NCH4) = (SIN1(S1+NCH4))*CODREM + CH4PRO
C
C  *********************************************************************
C  *                                                                   *
C  *       CALCULATE CELL MASS PRODUCED
C  *                                                                   *
C  *********************************************************************
C
C CELLY IS THE CELL YIELD IN KG/KG COD CONVERTED
      CELLM = CELLY*CODTOT*CH4YLD*CODCON
C
C CONVERT CELLS (KG/HR) TO KG-MOL/S
C
      CELLS = CELLM/(3600*CMW)
      SOUT1(S2+NBIOM) = SIN1(S2+NBIOM) + CELLS
C
C Adding Cell mass to the CISOLID substream and removing Mass from MIXED
C
      SOUT1(S2+NCOMP_NCC+1) = SOUT1(S2+NCOMP_NCC+1) + SOUT1(S2+
     +      NBIOM)
      SOUT1(S1+NCOMP_NCC+1) = SOUT1(S1+NCOMP_NCC+1) - SOUT1(S2+
     +      NBIOM)
C
C  *********************************************************************
C  *                                                                   *
C  *       CALCULATE SOLUBLE C-CONTAINING COMPOUNDS LEFT               *
C  *                                                                   *
C  *********************************************************************
C
      SOUT1(S1+NGLUC) = CODREM*SIN1(S1+NGLUC)
      SOUT1(S1+NXYLO) = CODREM*SIN1(S1+NXYLO)
      SOUT1(S1+NUNKN) = CODREM*SIN1(S1+NUNKN)
      SOUT1(S1+NSOLS) = CODREM*SIN1(S1+NSOLS)
      SOUT1(S1+NARAB) = CODREM*SIN1(S1+NARAB)
      SOUT1(S1+NGALA) = CODREM*SIN1(S1+NGALA)
      SOUT1(S1+NMANS) = CODREM*SIN1(S1+NMANS)
      SOUT1(S1+NGLUO) = CODREM*SIN1(S1+NGLUO)
      SOUT1(S1+NCELB) = CODREM*SIN1(S1+NCELB)
      SOUT1(S1+NXYLG) = CODREM*SIN1(S1+NXYLG)
      SOUT1(S1+NMANO) = CODREM*SIN1(S1+NMANO)
      SOUT1(S1+NGALO) = CODREM*SIN1(S1+NGALO)
      SOUT1(S1+NARAO) = CODREM*SIN1(S1+NARAO)
      SOUT1(S1+NACEO) = CODREM*SIN1(S1+NACEO)
      SOUT1(S1+NXYLL) = CODREM*SIN1(S1+NXYLL)
      SOUT1(S1+NETOH) = CODREM*SIN1(S1+NETOH)
      SOUT1(S1+NFURF) = CODREM*SIN1(S1+NFURF)
      SOUT1(S1+NHMF)  = CODREM*SIN1(S1+NHMF)
      SOUT1(S1+NLACI) = CODREM*SIN1(S1+NLACI)
      SOUT1(S1+NAACI) = CODREM*SIN1(S1+NAACI)
      SOUT1(S1+NGLYC) = CODREM*SIN1(S1+NGLYC)
      SOUT1(S1+NSUCC) = CODREM*SIN1(S1+NSUCC)
      SOUT1(S1+NDENA) = CODREM*SIN1(S1+NDENA)
      SOUT1(S1+NOIL)  = CODREM*SIN1(S1+NOIL)
      SOUT1(S1+NPROT) = CODREM*SIN1(S1+NPROT)
      SOUT1(S1+NEXTR) = CODREM*SIN1(S1+NEXTR)
      SOUT1(S1+NSLLN) = CODREM*SIN1(S1+NSLLN)
C
C **11/20/98; NH4Acet is now in the Mixed Substream
C      SOUT1(S2+NNH4A)  = CODREM*SIN1(S2+NNH4A)
C
      SOUT1(S1+NNH4A)  = CODREM*SIN1(S1+NNH4A)
C
C Mass Movement from CISOLID to MIXED No Longer NEEDED!!!
C Subtracting converted NH4ACET (Not Remaining) from CISOLID substream a
C adding Mass to MIXED
C
C      SOUT1(S2+NCC+1) = SOUT1(S2+NCC+1) - (SIN1(S2+NNH4A)
C     1                - SOUT1(S2+NNH4A))
C      SOUT1(S1+NCC+1) = SOUT1(S1+NCC+1) + (SIN1(S2+NNH4A)
C     1                - SOUT1(S2+NNH4A))
C
C
C  *********************************************************************
C  *                                                                   *
C  *       CALCULATE MASS OF REACTABLE SUBSTANCES INTO DIGESTOR        *
C  *                                                                   *
C  *********************************************************************
C
      REACIN =  SIN1(S1+NGLUC)*GMW +  SIN1(S1+NXYLO)*XYMW +
     2          SIN1(S1+NUNKN)*UMW +  SIN1(S1+NSOLS)*SMW +
     3          SIN1(S1+NARAB)*AMW +  SIN1(S1+NGALA)*GAMW +
     4          SIN1(S1+NMANS)*WAMW +  SIN1(S1+NGLUO)*GOMW +
     5          SIN1(S1+NCELB)*CBMW +  SIN1(S1+NXYLG)*XGMW +
     6          SIN1(S1+NMANO)*WOMW +  SIN1(S1+NGALO)*GLMW +
     7          SIN1(S1+NARAO)*AOMW +  SIN1(S1+NACEO)*AEMW +
     8          SIN1(S1+NXYLL)*XLMW +  SIN1(S1+NETOH)*EMW +
     9          SIN1(S1+NFURF)*FMW  +  SIN1(S1+NHMF)*HMW  +
     *          SIN1(S1+NCH4)*C4MW  +  SIN1(S1+NLACI)*ALMW +
     1          SIN1(S1+NAACI)*AAMW +  SIN1(S1+NGLYC)*GYMW +
     2          SIN1(S1+NSUCC)*SUMW +  SIN1(S1+NDENA)*DMW +
     3          SIN1(S1+NOIL)*WLMW   + SIN1(S1+NNH4A)*AMAMW +
     4          SIN1(S1+NEXTR)*EXMW +  SIN1(S1+NPROT)*PRMW +
     5          SIN1(S1+NSLLN)*SLMW
C
C **02/16/2001; Add protein, extract, lgnsol
C
C **11/20/98; NH4Acet is now in the Mixed Substream
C     3          SIN1(S1+NOIL)*WLMW   + SIN1(S2+NNH4A)*AMAMW
C
C
C  CALCULATE THE MASS THAT REACTED
C
      REACTD = (1.-CODREM)*REACIN
C
C  *********************************************************************
C  *                                                                   *
C  *       CALCULATE CO2 PRODUCTION                                    *
C  *                                                                   *
C  *********************************************************************
C
C  CALCULATE THE AMOUNT AVAILABLE FOR CO2 PRODUCTION
C
      CO2AVL = REACTD - (CELLM/3600.) -  CH4MAS
C
      WRITE(USER_NHSTRY,*)'CO2AVL= ',CO2AVL
C CALCULATE THE FINAL FLOWRATE OF CO2 OUT
C
      CO2OUT = CO2AVL/CO2MW
      WRITE(USER_NHSTRY,*)'CO2OUT= ',CO2OUT
C DETERMINE THE MOLE FRACTION OF CO2 POTENTIALLY FORMED
      CO2FRC = CO2OUT/(CO2OUT + CH4PRO)
C     THE FINAL CONCENTRATION OF  CH4 MAY BE SET
      CH4FIN = REAL(4)
      CO2FIN = CH4PRO/CH4FIN - CH4PRO
      WRITE(USER_NHSTRY,*)'CO2FIN= ',CO2FIN
C CHECK TO SEE IF THE CO2 CALCULATED BY SETTING THE VOLUMETRIC
C OUTLET IS GREATER THAN THE POTENTIAL FORMED.  IF SO, THEN SET
C THE CO2 OUT EQUAL TO THE MAXIMUM POTENTIAL.  IF NOT, SET THE
C CO2 FORMED EQUAL TO THE VOLUMETRIC SPECIFICATION AND MAKE
C WATER WITH THE REMAINING.
      IF (CO2FIN .GT. CO2OUT) THEN
         SOUT1(S1+NCO2) = CO2OUT + SIN1(S1+NCO2)
      ELSE
         SOUT1(S1+NCO2) = CO2FIN + SIN1(S1+NCO2)
         SOUT1(S1+NH2O) = (CO2OUT-CO2FIN)*(CO2MW/WMW)+SOUT1(S1+NH2O)
      END IF
C
C   AS A CHECK, CALCULATE THE MOLE FRACTION CO2 VS CH4
C   AND WRITE OUT THE RESULTS.
C
      CO2FRC = SOUT1(S1+NCO2)/(SOUT1(S1+NCO2) + SOUT1(S1+NCH4))
      CH4FRC = SOUT1(S1+NCH4)/(SOUT1(S1+NCO2) + SOUT1(S1+NCH4))
C
      WRITE(USER_NHSTRY,*)'CO2FRC,CH4FRC= ',CO2FRC,CH4FRC
C
C
C  *********************************************************************
C  *                                                                   *
C  *       CALCULATE H2S PRODUCTION                                    *
C  *                                                                   *
C  *********************************************************************
C
C  ASSUME H2S WILL BE FORMED FROM ALL SOLUBLE SO4-CONTAINING COMPOUNDS
C
       SACON = 0.347
C SACON IS THE SULFURIC ACID CONVERSION TO H2S (LB H2S/LB H2SO4)
      ASCON = 0.273
C ASCON IS THE AMMONIUM SULFATE CONVERSION TO H2S (LB H2S/LB (NH4)2SO4)
C
       CEFF = REAL(5)
C      CEFF = FRACTION OF SOLUBLE SO4-CONTAINING COMPOUNDS CONVERTED
C
      H2SFRM = SACON*SIN1(S1+NH2SO)*SAMW*CEFF +
     1         ASCON*SIN1(S1+NNH4S)*ASMW*CEFF
C **11/20/98; RJW NH4SO4 is now in Mixed Substream
C     1         ASCON*SIN1(S2+NNH4S)*ASMW*CEFF
C
C H2SFRM IS THE AMOUNT OF H2S FORMED (KG/S)
C
      H2SMOL = H2SFRM/HSMW
C H2SMOL IS THE H2S FORMED ON A MOLE BASIS (KG-MOL/S)
C
      WRITE(USER_NHSTRY,*)'H2SFRM,H2SMOL= ',H2SFRM,H2SMOL
C ASSUME WHAT IS NOT CONVERTED TO H2S GOES TO WATER
C
      WATFRM = (1-SACON)*SIN1(S1+NH2SO)*SAMW*CEFF +
     1         (1-ASCON)*SIN1(S1+NNH4S)*ASMW*CEFF
C **11/20/98; NH4SO4 is now in the Mixed Substream
C     1         (1-ASCON)*SIN1(S2+NNH4S)*ASMW*CEFF
      WATMOL = WATFRM/WMW
      WRITE(USER_NHSTRY,*)'WATFRM,WATMOL= ',WATFRM,WATMOL
C
      SOUT1(S1+NH2SO) = (1.0-CEFF)*SIN1(S1+NH2SO)
      SOUT1(S1+NNH4S) = (1.0-CEFF)*SIN1(S1+NNH4S)
C **11/20/98; NH4SO4 is now in the Mixed Substream
C      SOUT1(S2+NNH4S) = (1.0-CEFF)*SIN1(S2+NNH4S)
C CALCULATE THE OUTLET FLOWRATES
      SOUT1(S1+NH2S) = SOUT1(S1+NH2S) + H2SMOL
      SOUT1(S1+NH2O) = SOUT1(S1+NH2O) + WATMOL
C
      RETURN
      END


